package testframework;

import java.util.ArrayList;
import java.io.*;

/**
 * Command represents a single action in interface.xml
 * @author lzcarl
 *
 */
public class Command {

	public String name = "";
	public String self = "";
	public String action = "";
	public String count = "";
	public String input_file = "";
	public String type = "";
	public long range = 0;
	public int index = 0;
	public String group = "";
	public String[] names = null;
	public String time = "";
	public String hierarchy = "";
	
	/**
	 * whether the command is finished
	 */
	public boolean finished = false;
	/**
	 * count for the times the command has executed
	 */
	public int count_now = 0;
	
	public ArrayList<String> input_range;
	
	public void loadInputRange() throws Exception{
		input_range = new ArrayList<String>();
		// Open the file that is the first
		// command line parameter
		FileInputStream fstream = new FileInputStream(input_file);
		// Get the object of DataInputStream
		DataInputStream in = new DataInputStream(fstream);
		BufferedReader br = new BufferedReader(new InputStreamReader(in));
		String strLine;
		// Read File Line By Line
		while ((strLine = br.readLine()) != null) {
			// Print the content on the console
			input_range.add(strLine);
		}
		// Close the input stream
		in.close();
	}
	
	public String toString() {
		return "[name:" + name + ", self:" + self + ", action:" + 
			action + ", count:" + count + ", input_file:" + input_file + 
			", type:" + type + "]";
	}
}
