/**
 * 
 */
package testframework;

import java.util.*;
import testframework.utils.*;

/**
 * @author lzcarl
 *
 */
public class CommandDriver {
	
	private ArrayList<Command> cmd_list;
	public HtmlUnitWrapper htmlUnit;
	
	public CommandDriver(ArrayList<Command> cmd_list) {
		this.cmd_list = cmd_list;
	}
	
	/**
	 * Get next command list
	 * Assume the list items are not changed
	 * @return
	 */
	public ArrayList<Command> next() throws Exception{
		boolean finished = true;
		finished = incrementList(0);
		if(finished)
			return null;
		else
			return cmd_list;
	}
	
	/**
	 * refined version of setIndex, 
	 * @throws Exception
	 */
	public boolean incrementList(int index) throws Exception {
		if(index == cmd_list.size())
			return true;
		Command cmd = cmd_list.get(index);
		ControlUtils.setRange(cmd);
		boolean needInc = incrementList(index + 1);
		boolean result = false;
		if(ControlUtils.disabled(cmd)) {
			return needInc;
		}
		if(needInc)
			cmd.index ++;
		if(cmd.index == cmd.range) {
			cmd.index = 0;
			result = true;
		}
		if(cmd.group.equals("true"))
			cmd.name = cmd.names[cmd.index];
		return result;
	}
}
