package testframework;

import net.sourceforge.jwebunit.junit.WebTestCase;
import net.sourceforge.jwebunit.api.*;
import java.io.*;
import traffic.*;
import java.util.Calendar;
import java.text.SimpleDateFormat;

public class ExampleWebTestCase extends WebTestCase {

	public static final String DATE_FORMAT_NOW = "HH:mm:ss.SSS";
	private TestResult result = new TestResult();
	private String[] result_set = null;
	
	public void setUp() {
		try {
			super.setUp();
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		//setBaseUrl("https://mail.google.com");
		setBaseUrl("https://web-rerunner.appspot.com/");
	}

	private void startTrafficAnalyser() {
		try {
			//get the parameters
			ConfigModule.load("network.properties");
			TrafficAnalyser.clientIP = ConfigModule.getProperty("clientIP");
			TrafficAnalyser.NIC = ConfigModule.getProperty("NIC");
			TrafficAnalyser.proto = ConfigModule.getProperty("proto");
			TrafficAnalyser.result = result;
			TrafficAnalyser.defaultStart();
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	private void getInputStream() {
		ITestingEngine engine = getTestingEngine();
		InputStream in = engine.getInputStream();
		StringBuilder sb = new StringBuilder();
		String line;
		try {
			BufferedReader reader = new BufferedReader(new InputStreamReader(in));
			while  ((line = reader.readLine()) != null) {
				sb.append(line).append("\n");
			}
			in.close();
			System.out.println(sb.toString());
		} catch (Exception ie) {
			ie.printStackTrace();
		}
	}
	
	public static String now() {
		Calendar cal = Calendar.getInstance();
		SimpleDateFormat sdf = new SimpleDateFormat(DATE_FORMAT_NOW);
		return sdf.format(cal.getTime());

	}
	
	private void trace(String msg) {
		System.out.println(now() + ": " + msg);
	}
	
	private void round(String username, String password, int index) {
		try {
			Thread.sleep(2000);
			trace("Start at Gmail");
			TestResult.changeKey("Index Page");
			beginAt("/");
			trace("Input Username");
			setTextField("Email", "powd");
			trace("Input Password");
			setTextField("Passwd", "986547");	
			TestResult.changeKey("Submit");
			trace("Submit the form");
			submit();
			assertTitleEquals("Gmail: Email from Google");			
			Thread.sleep(1000);
			result_set[index] = TestResult.getResult();
			TestResult.clear();
		} catch (InterruptedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	private void round_special() {
		//I need to check if HTMLUnit is able to navigate to a certain element 
		//and if it is able to simulate the user's key press
		try {
			Thread.sleep(2000);
			ITestingEngine engine = getTestingEngine();
			trace("Start the web-rerunner page");
			beginAt("/");
			String xpath = "/html/body/table/tbody/tr[2]/td/input";
			IElement textbox = engine.getElementByXPath(xpath);
			System.out.println(textbox.getTextContent());
			textbox.setTextContent("Amazon");
			textbox = engine.getElementByXPath(xpath);
			System.out.println(textbox.getTextContent());
			xpath = "/html/body/table/tbody/tr[2]/td[2]/button";
			this.clickElementByXPath(xpath);
			
			Thread.sleep(1000);
		} catch (Exception ie) {
			ie.printStackTrace();
		}
	}

	public void test1() {
		startTrafficAnalyser();
		round_special();
		/*result_set = new String[4];
		//run 4 times
		round("pow", "986547", 0);
		round("dvd", "986547", 1);
		round("powd", "f6547", 2);
		round("pord", "9847", 3);
		int i = 0;
		for(i = 0; i < 4; i ++) {
			System.out.println("Test round " + i + ":\n" + result_set[i]);
		}
		System.out.println("The infomration entropy is:" + InfoQuantifier.get_entropy(result_set));*/
		//clickLink("google");
		//assertTitleEquals("Google");

	}
}
