package testframework;

import java.util.*;
import java.math.*;

public class InfoQuantifier {
	/**
	 * Get the entropy of the data
	 * which is defined the number of clusters
	 * @param data
	 * @return
	 */
	public static double get_entropy(ArrayList<String> data) {
		int size = get_clusters(data).size();
		return Math.log(size) / Math.log(2);
	}
	
	
	
	/**
	 * Classify the data into different clusters
	 * @param data
	 * @return
	 */
	public static HashSet<String> get_clusters(ArrayList<String> data) {
		int i = 0;
		HashSet<String> clusters = new HashSet<String>();
		for(i = 0; i < data.size(); i ++) {
			clusters.add(data.get(i));
		}
		return clusters;
	}
	
	public static HashMap<String, Integer> get_piles(ArrayList<String> data) {
		HashMap<String, Integer> map = new HashMap<String, Integer>();
		int i = 0;
		for(i = 0; i < data.size(); i ++) {
			String key = data.get(i);
			if(map.containsKey(data.get(i))) {
				int v = map.get(key);
				map.put(key, v + 1);
			} else {
				map.put(key, 1);
			}	
		}	
		return map;
	}
	
	public static double get_cond_entropy(ArrayList<String> data) {
		double data_size = data.size();
		double pile_size = 0;
		double result = 0;
		HashMap<String, Integer> map = get_piles(data);
		Set<String> keys = map.keySet();
		for(String key : keys) {
			pile_size = map.get(key);
			result += (pile_size / data_size) * (Math.log(pile_size) / Math.log(2));
		}
		return result;
	}
	
	public static String roundto(String traffic, int base) {
		int i = 0;
		String result = "";
		char c = 0;
		String num_str = "";
		int num = 0;
		int m = 0;
		for(i = 0; i < traffic.length(); i ++) {
			c = traffic.charAt(i);
			if(c == '<' || c == '>') {
				if(!num_str.equals("")) {
					num = Integer.parseInt(num_str);
					m = (int)Math.ceil((double)num / base) * base;
					result = result + String.valueOf(m);
					num_str = "";
				}
				result = result + c;
			} else {
				num_str = num_str + c;
			}
		}
		if(!num_str.equals("")) {
			num = Integer.parseInt(num_str);
			m = (int)Math.ceil((double)num / base) * base;
			result = result + String.valueOf(m);
			num_str = "";
		}
		return result;
	}
	
	public static void round_results(ArrayList<String> data, int base) {
		for(int i = 0; i < data.size(); i ++) {
			//String parts[] = data.get(i).split(":");
			//String traffic = parts[1].trim();
			String traffic = data.get(i).trim();
			if(!traffic.equals("null"))
				traffic = roundto(traffic, base);
			data.set(i, traffic);
		}
	}
}
