package testframework;

import java.io.File;
import java.util.ArrayList;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

public class InterfaceParser {
	private Document doc;
	private ArrayList<Command> cmdList = new ArrayList<Command>();
	
	public InterfaceParser(String filename) throws Exception{
		  File file = new File(filename);
		  DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
		  DocumentBuilder db = dbf.newDocumentBuilder();
		  doc = db.parse(file);
		  doc.getDocumentElement().normalize();

	}
	
	public ArrayList<Command> parse() throws Exception{
		NodeList nodeLst = doc.getElementsByTagName("Widget");
		for (int s = 0; s < nodeLst.getLength(); s++) {
		    Node fstNode = nodeLst.item(s);
		    if (fstNode.getNodeType() == Node.ELEMENT_NODE) {
		    	Element fstElmnt = (Element) fstNode;
		    	Command cmd = new Command();
		    	cmd.name = fstElmnt.getAttribute("name");
		    	cmd.self = fstElmnt.getAttribute("self");
		    	cmd.action = fstElmnt.getAttribute("action");
		    	cmd.count = fstElmnt.getAttribute("count");
		    	cmd.input_file = fstElmnt.getAttribute("input_file");
		    	cmd.type = fstElmnt.getAttribute("type");
		    	cmd.group = fstElmnt.getAttribute("group");
		    	cmd.hierarchy = fstElmnt.getAttribute("hierarchy");
		    	if(cmd.group.equals("true")) {
		    		cmd.names = cmd.name.split(";");
		    		cmd.name = cmd.names[0];
		    	}
		    	cmd.index = 0;
		    	cmd.time = fstElmnt.getAttribute("time");
		    	cmdList.add(cmd);
		    }
		}
		return cmdList;
	}
	
	public static void main(String[] args) {
		try {
			InterfaceParser parser = new InterfaceParser("interface.xml");
			ArrayList<Command> result = parser.parse();
			for(Command cmd : result) {
				System.out.println("Command " + cmd);
			}
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
	}
}
