package testframework;

import java.util.*;

import com.gargoylesoftware.htmlunit.*;
import com.gargoylesoftware.htmlunit.html.*;

public class ResourceLocator {

	public static String method = "GWTID";
	public static ArrayList<String> accepted_tags= new ArrayList<String>();
	public static String gwtid = "gwt-";
	
	public static void initAcceptedTags(String[] tags) {
		accepted_tags.clear();
		for(String tag : tags) {
			accepted_tags.add(tag);
		}
	}
	
	/**
	 * locate the DOM element
	 * @param page
	 * @param path
	 * @return
	 * @throws Exception
	 */
	public static HtmlElement locate(HtmlPage page, String path) throws Exception{
		if(method.equals("id")) {
			return page.getElementById(path);
		} else if(method.equals("xpath")) {
			return (HtmlElement)page.getByXPath(path).get(0);
		} else if(method.equals("GWTContainer")) {
			// GWT container
			// scan the descendents and
			// return the element which are input, button
			// The assumption is GWT layout is table-driven
			// every specific element (input, button) is put into a table cell
			HtmlElement container = page.getElementById(path);
			List<HtmlElement> list = container.getHtmlElementsByTagNames(accepted_tags);
			return list.get(0);
		} else if (method.equals("GWTID")){
			return page.getElementById(gwtid + path);
		} else {
			throw new Exception("Unknown locating method");
		}
	}
	
}
