package testframework;

/**
 * Storing the test result for one run.
 * Should be in the following format:
 * action -> traffic pattern
 * traffic pattern (string): OutSize>InSize<...
 * @author lzcarl
 *
 */

import java.util.*;
import java.io.*;

public class TestResult {
	private static HashMap<String, String> records = new HashMap<String, String>();
	private static String currentKey = "";
	
	public static void test(String traffic) {
		System.out.println(traffic);
	}
	
	public static boolean isEntryEmpty(String key) {
		if(records.get(key).equals("null"))
			return true;
		else
			return false;
	}
	
	public static void updateEntry(String traffic) {
		//System.out.println(traffic);
		if(currentKey == "")
			return;
		String value = records.get(currentKey);
		if(value != "null") 
			value = value + traffic;
		else
			value = traffic;
		records.put(currentKey, value);
	}
	
	public static void changeKey(String newKey) {
		currentKey = newKey;
		records.put(currentKey, "null");
	}
	
	public static void printResult() {		
		Set<String> set = records.keySet();
		Iterator<String> i = set.iterator();
		String key = "";
		String value = "";
		while(i.hasNext()) {
			key = i.next();
			value = records.get(key);
			System.out.println(key + ":" + value);
		}	
	}
	
	public static void clear() {
		records.clear();		
	}
	
	public static String getResult() {
		Set<String> set = records.keySet();
		Iterator<String> i = set.iterator();
		String key = "";
		String value = "";
		String str = "";
		while(i.hasNext()) {
			key = i.next();
			value = records.get(key);
			System.out.println(key + ":" + value);
			//str.append(key + ":" + value + "\n");
			if(!value.contains("null"))
				str += value;
		}
		if(str.toString().equals(""))
			str = "null";
		return str.toString();
	}
	
	public static void removeEmptyEntries() {
		Set<String> keys = new HashSet<String>();
		keys.addAll(records.keySet());
		int i = 0;
		for(String key : keys) {
			if(records.get(key).equals("null")) {
				records.remove(key);
			}
		}
	}
	
	public static void main(String[] args) {
		/*TestResult t = new TestResult();
		t.changeKey("Input1");
		t.updateEntry(">80");
		t.updateEntry("<90");
		t.changeKey("submit");
		t.updateEntry(">1234");
		t.updateEntry("<3453");	
		t.changeKey("click");
		t.printResult();*/
		TestResult.changeKey("Input1");
		TestResult.updateEntry("<80>90<34<11<562>3334");
		TestResult.printResult();
	}
}
