package testframework.ui;

import java.awt.BorderLayout;
import java.awt.Font;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.border.Border;

public class AnalysisPanel extends JPanel implements ActionListener {

	JButton btnSourceDir;
	JButton btnInputFile1;
	JButton btnInputFile2;
	
	JTextField txtSourceDir;
	JTextField txtInputFile1;
	JTextField txtInputFile2;
	
	JButton btnStart;
	
	JTextArea txtOutput;
	
	Font font;
	JFrame frame;
	
	FileContentDialog fcd ;
	
    public boolean start = false;
    public boolean stop = true;
    
	final JFileChooser fc = new JFileChooser();
	
	public AnalysisPanel(Font font, JFrame frame) {
		
		//String [] fonts = getToolkit().getFontList();
		//font = new Font(fonts[1], Font.PLAIN, 20);
		this.font = font;
		this.frame = frame;
		
		fcd = new FileContentDialog(frame, "Child", true, font);
		fc.setCurrentDirectory(new File("F:\\prj\\soot\\workspace\\incomeTest\\"));
		
		//this.setSize(900,600);
		//this.setLayout(new GridLayout(0,1));
		this.setLayout(new BorderLayout());
		JPanel inputPanel = new JPanel(new GridLayout(0,1));
		JPanel buttonPanel = new JPanel();
		txtOutput = new JTextArea("");//, 40, 20);
		txtOutput.setFont(font);
		JScrollPane outputPanel = new JScrollPane(txtOutput);
		//JPanel outputPanel = new JPanel();
		
		/*
		this.add(inputPanel);//, BorderLayout.NORTH);
		this.add(buttonPanel);//, BorderLayout.CENTER);
		this.add(outputPanel);//, BorderLayout.SOUTH);
		*/
		this.add(inputPanel, BorderLayout.NORTH);
		this.add(buttonPanel, BorderLayout.WEST);
		this.add(outputPanel, BorderLayout.CENTER);
		
		inputPanel.setFont(font);
		buttonPanel.setFont(font);
		outputPanel.setFont(font);
		
		Border titled2 = BorderFactory.createTitledBorder("Start to analysis");
		buttonPanel.setBorder(titled2);
		btnStart = new JButton("Start");
		btnStart.setFont(font);
		buttonPanel.add(btnStart, BorderLayout.CENTER);

		Border titled3 = BorderFactory.createTitledBorder("Output");
		outputPanel.setBorder(titled3);
		outputPanel.setVerticalScrollBarPolicy(
				JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
		//outputPanel.add(txtOutput, BorderLayout.NORTH);
		
		
		//////// INPUT PANEL ////////////
		Border titled1 = BorderFactory.createTitledBorder("Output");
		inputPanel.setBorder(titled1);
		
		JLabel lblSourceDir = new JLabel ("Source Code Path:            ");
		JLabel lblInputFile1 = new JLabel("Input File1: behavior model: ");
		JLabel lblInputFile2 = new JLabel("Input File2: sensitive data: ");
		txtSourceDir = new JTextField("", 30);
		txtInputFile1 = new JTextField("", 30);
		txtInputFile2 = new JTextField("", 30);
		//JTextArea txtInputFile1 = new JTextArea("", 10, 40);
		//JTextArea txtInputFile2 = new JTextArea("", 10, 40);
		btnSourceDir = new JButton("Choose");
		btnInputFile1 = new JButton("Open");
		btnInputFile2 = new JButton("Open");
		JLabel lblDummy1 = new JLabel("");
		JLabel lblDummy2 = new JLabel("");
		JLabel lblDummy3 = new JLabel("");
		
	

		lblSourceDir.setFont(font);
		lblInputFile1.setFont(font);
		lblInputFile2.setFont(font);
		txtSourceDir.setFont(font);
		txtInputFile1.setFont(font);
		txtInputFile2.setFont(font);
		btnSourceDir.setFont(font);
		btnInputFile1.setFont(font);
		btnInputFile2.setFont(font);
		
		
		/*
		for (int i = 0; i < fonts.length; i++)
		   {
		   font = new Font(fonts[i], Font.BOLD, font_size);
		   System.out.println(font.toString());
		   //g.setFont(font);
		   //g.drawString(fonts[i], x, y);
		   y += line_spacing;
		   }
		*/
		
		JPanel paneSourceDir = new JPanel();
		JPanel paneInputFile1 = new JPanel();
		JPanel paneInputFile2 = new JPanel();
		
		
		inputPanel.add(paneSourceDir);//, BorderLayout.NORTH);
		inputPanel.add(paneInputFile1);//, BorderLayout.CENTER);
		inputPanel.add(paneInputFile2);//, BorderLayout.SOUTH);
		
				
		
		paneSourceDir.add(lblSourceDir, BorderLayout.WEST);
		paneSourceDir.add(txtSourceDir, BorderLayout.CENTER);
		paneSourceDir.add(btnSourceDir, BorderLayout.EAST);
		
		paneInputFile1.add(lblInputFile1, BorderLayout.WEST);
		paneInputFile1.add(txtInputFile1, BorderLayout.CENTER);
		paneInputFile1.add(btnInputFile1, BorderLayout.EAST);
		
		paneInputFile2.add(lblInputFile2, BorderLayout.WEST);
		paneInputFile2.add(txtInputFile2, BorderLayout.CENTER);
		paneInputFile2.add(btnInputFile2, BorderLayout.EAST);
		
		btnSourceDir.addActionListener(this);
		btnInputFile1.addActionListener(this);
		btnInputFile2.addActionListener(this);
		
		btnStart.addActionListener(this);
		

		

			    
		/*
		inputPanel.add(lblSourceDir);
		//inputPanel.add(lblDummy1);
		inputPanel.add(txtSourceDir);
		inputPanel.add(btnSourceDir);		

		inputPanel.add(lblInputFile1);
		//inputPanel.add(lblDummy2);
		inputPanel.add(txtInputFile1);
		inputPanel.add(btnInputFile1);
		
		inputPanel.add(lblInputFile2);
		//inputPanel.add(lblDummy3);
		inputPanel.add(txtInputFile2);
		inputPanel.add(btnInputFile2);
		*/
		
		System.out.println(inputPanel.getSize().toString());
		System.out.println(buttonPanel.getSize().toString());
		System.out.println(outputPanel.getSize().toString());
		
	}
	
	@Override
	public void actionPerformed(ActionEvent e) {
		int returnVal;
		String filePath;
		
		if (e.getSource() == btnStart) {
			System.out.println("Start Button is clicked");
			start = true;
			return;
		}

	    //Handle open button action.
	    if (e.getSource() == btnSourceDir) {
	    	fc.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);	    	
	    	returnVal = fc.showOpenDialog(this);
	    	if (returnVal == JFileChooser.APPROVE_OPTION) {
	    		filePath = fc.getSelectedFile().getAbsolutePath();
	    		txtSourceDir.setText(filePath);
	    	}
	    } else if (e.getSource() == btnInputFile1) {
    		fc.setFileSelectionMode(JFileChooser.FILES_ONLY);
	    	returnVal = fc.showOpenDialog(this);
	    	if (returnVal == JFileChooser.APPROVE_OPTION) {
	    		filePath = fc.getSelectedFile().getAbsolutePath();
	    		txtInputFile1.setText(filePath);	    		
	    		fcd.loadFile(filePath);
	    	}
	    } else if (e.getSource() == btnInputFile2) {
    		fc.setFileSelectionMode(JFileChooser.FILES_ONLY);
	    	returnVal = fc.showOpenDialog(this);
	    	if (returnVal == JFileChooser.APPROVE_OPTION) {
	    		filePath = fc.getSelectedFile().getAbsolutePath();
	    		txtInputFile2.setText(filePath);	    		
	    		fcd.loadFile(filePath);
	    	}
	    }
	}
	
	public JTextArea getLogObj() {
		return txtOutput;
	}

	
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		JFrame frame = new JFrame("Display image");
		Font font = frame.getFont();
		AnalysisPanel panel = new AnalysisPanel(font, frame);
		frame.getContentPane().add(panel);
		/*
		JButton bt = new JButton("Update");
		frame.getContentPane().add(bt);
		bt.addActionListener(new ActionListener () {

			@Override
			public void actionPerformed(ActionEvent e) {
				panel.updateTraffic();
			}
		});
		*/
		frame.setSize(772, 705);
		frame.setVisible(true);
	}

}
