package testframework.ui;

import java.io.*;
import java.awt.BorderLayout;
import java.awt.Dialog;
import java.awt.Font;
import java.awt.Frame;
import java.awt.GraphicsConfiguration;
import java.awt.Window;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;

public class FileContentDialog extends JDialog implements ActionListener {
	private JLabel lblFilename;
	private JButton btnClose;
	private JTextArea txtFileContent;
	private Font font;
	
	
	public FileContentDialog(JFrame frame, String title, boolean modal, Font font) {	
		super(frame, title, modal);
		
		this.font = font;
		
		lblFilename = new JLabel();
		btnClose = new JButton("Close");
		btnClose.addActionListener(this);
		txtFileContent = new JTextArea("", 10, 30);
		JScrollPane outputPanel = new JScrollPane(txtFileContent);
		outputPanel.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
		
		lblFilename.setFont(font);
		btnClose.setFont(font);
		txtFileContent.setFont(font);
		
		this.setLayout(new BorderLayout());
		add(lblFilename, BorderLayout.NORTH);
		add(outputPanel, BorderLayout.CENTER);
		add(btnClose, BorderLayout.SOUTH);
		this.pack();
		this.setVisible(false);
		
	}
	

	public void loadFile(String filename) {
		lblFilename.setText("File: " + filename);
		BufferedReader input;
		txtFileContent.setText("");
		try {
			input = new BufferedReader(new FileReader(filename));
			try {
				String line = null;
				while ((line = input.readLine()) != null) {
					txtFileContent.append(line);
					txtFileContent.append(System.getProperty("line.separator"));
				}				
			} finally {
				input.close();
			}
		} catch (Exception e) {
			System.out.println(e.toString());
		}
		this.setVisible(true);
	}

	@Override
	public void actionPerformed(ActionEvent e) {
		this.setVisible(false);		
	}
	
	


}
