package testframework.ui;
/**
 * 
 */


import java.awt.BorderLayout;

import java.awt.Dimension;
import java.awt.Font;
import java.awt.Graphics2D;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.geom.Rectangle2D;
import java.awt.image.BufferedImage;

import javax.swing.BorderFactory;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JComponent;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTabbedPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.UIManager;
import javax.swing.border.Border;

import org.jfree.chart.ChartFactory;
import org.jfree.chart.ChartUtilities;
import org.jfree.chart.JFreeChart;
import org.jfree.chart.axis.CategoryAxis;
import org.jfree.chart.axis.ValueAxis;
import org.jfree.chart.plot.CategoryPlot;
import org.jfree.chart.plot.Plot;
import org.jfree.chart.plot.PlotOrientation;
import org.jfree.data.category.DefaultCategoryDataset;
import org.jfree.data.general.DefaultPieDataset;
import java.io.File;
import java.awt.*;
/**
 * @author zkh
 *
 */
public class SidebusterDemo implements ActionListener {
	private JTextField txtUrl;
	private JTextArea txtOutput;
	private TrafficPanel paneTraffic;
	private JPanel paneGraph;
    private DefaultCategoryDataset graphDataset = new DefaultCategoryDataset();
   	private AnalysisPanel paneDect;
	
    private final BufferedImage image = new BufferedImage(300, 250, BufferedImage.TYPE_INT_RGB);
    private final Graphics2D g2 = image.createGraphics();
    private final Rectangle2D chartArea = new Rectangle2D.Double(0, 0, 300, 250);
    
    private JTabbedPane paneTabbed;
    
    JFrame frame;
    public boolean start;
    public boolean end;
    Font font;

    
	public SidebusterDemo()  {
		
		graphDataset = new DefaultCategoryDataset();
		
		
		String lf = UIManager.getSystemLookAndFeelClassName();
		try {
        UIManager.setLookAndFeel(lf);
		} catch (Exception e) {
			System.out.print(e.toString());
		}

        frame = new JFrame("Sidebuster Demo");
        
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        
        
        JPanel paneRoot = (JPanel) frame.getContentPane();
        paneTabbed = new JTabbedPane();
        paneRoot.add(paneTabbed, BorderLayout.NORTH);

		String [] fonts = paneRoot.getToolkit().getFontList();
		font = new Font(fonts[1], Font.BOLD, 20);
		

        
        paneDect = new AnalysisPanel(font, frame);//new JPanel(new BorderLayout());
        JPanel pane = new JPanel(new BorderLayout());
        
        paneTabbed.addTab("Analysis", paneDect);
        paneTabbed.addTab("Quantification", pane);  
        paneTabbed.setSelectedIndex(1);
        
        
        //JPanel pane = (JPanel) frame.getContentPane();
        
        
        JPanel pane_up = buildPanelUp();
        JPanel pane_down = new JPanel();
        JScrollPane pane_left = buildPanelLeft();
        JPanel pane_right = buildPanelRight();
        
        //pane.setLayout(new GridLayout(2,0));
        //pane.add(pane_up);
        //pane.add(pane_down);
        //pane_down.add(pane_left, BorderLayout.WEST);
        //pane_down.add(pane_right, BorderLayout.EAST);
        
        pane.add(pane_up, BorderLayout.NORTH);
        pane.add(pane_left, BorderLayout.WEST);
        pane.add(pane_right, BorderLayout.CENTER);
        
   
        //Display the window.
        frame.pack();
        frame.setVisible(true);
        //frame.setSize(672, 625);
        System.out.println(pane.getSize().toString());
        System.out.println(paneDect.getSize().toString());
        adjustFrameSize();
	};
	
	public void setFrameSize(int width, int height) {
		frame.setSize(width, height);
		
	}
	public void adjustFrameSize() {
		Dimension d = getFrameSize();
		setFrameSize(d.width + 100 ,d.height);
	}
	public Dimension getFrameSize() {
		return frame.getSize();
	}


	private JPanel buildPanelUp() {
		// TODO Auto-generated method stub
		JPanel pane = new JPanel();
		JLabel lblUrl = new JLabel("URL: ");
		txtUrl = new JTextField("", 30);
		JButton btnStart = new JButton("Start");
		
		lblUrl.setFont(font);
		txtUrl.setFont(font);
		btnStart.setFont(font);
		
		pane.add(lblUrl, BorderLayout.WEST);
		pane.add(txtUrl, BorderLayout.CENTER);
		pane.add(btnStart, BorderLayout.EAST);
		
		btnStart.addActionListener(this);
		
		return pane;
	}

	public void actionPerformed(ActionEvent e) {
		clickStartButton(e);
	}
	
	private JScrollPane buildPanelLeft() {
		txtOutput = new JTextArea("", 10, 30);
		txtOutput.setFont(font);
		JScrollPane pane = new JScrollPane(txtOutput);
		
		Border titled = BorderFactory.createTitledBorder("Output");
		pane.setBorder(titled);

		pane.setVerticalScrollBarPolicy(
				JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);

		//pane.add(txtOutput, BorderLayout.CENTER);
		return pane;

	}

	private JPanel buildPanelRight() {
		JPanel pane = new JPanel();
		
		paneTraffic = getTrafficPanel();		
		//JPanel pane2 = new JPanel();
		Border titled = BorderFactory.createTitledBorder("Traffic");
		paneTraffic.setBorder(titled);
		//paneTraffic.setSize(200,200);
		//pane2.setBorder(titled);


		//pane2.add(paneTraffic, BorderLayout.CENTER);
		
		paneGraph = getGraphPanel();
		pane.setLayout(new GridLayout(0,1));
		//pane.setLayout(new BorderLayout());
		//pane.add(pane2);
		pane.add(paneTraffic);//, BorderLayout.CENTER);
		pane.add(paneGraph);//, BorderLayout.SOUTH);
		return pane;

	}


	private TrafficPanel getTrafficPanel() {
		TrafficPanel pane = new TrafficPanel(font);
		return pane;
	}

	private JPanel getGraphPanel() {
		JPanel pane = new JPanel();
		Border titled = BorderFactory.createTitledBorder("Graph");
		pane.setBorder(titled);

		ImageIcon icon = new ImageIcon(image);
        JLabel label = new JLabel(icon);
        pane.add(label,BorderLayout.CENTER);
		
        //testAddToGraphDataset();
		
		return pane;
	}

	private void testAddToGraphDataset() { 
		addGraphData(10.0);		
		addGraphData(7.0);
		addGraphData(8.0);
		addGraphData(5);
		addGraphData(1);
		
		updateGraph();
	}

	public JTextArea getLogObject() {
		return txtOutput;
	}
	
	public String getUrl() {
		return txtUrl.getText();
	}
	
	public void setUrl(String url) {
		txtUrl.setText(url);
		
	}

	public void clickStartButton(ActionEvent e) {
		// TODO: add your code to response the button click event
		// Currently, it update the trafficType only.
		//updateTraffic(paneTraffic.getTrafficType()+1);
		/*int trafficType = paneTraffic.getTrafficType();
		if (trafficType == 0)
			setUploadTraffic("100 Bytes");
		else if (trafficType == 1)
			setDownloadTraffic("200 Bytes");
		else if (trafficType == 2)
			setTraffic("150 Bytes", "300 Bytes");
		else
			clearTraffic();
		
		this.getLogObject().append(String.valueOf(paneTraffic.getTrafficType()) + "\n");
		this.setUrl(this.getUrl() + String.valueOf(paneTraffic.getTrafficType()) + "\n");
		this.addGraphData(paneTraffic.getTrafficType());
		this.updateGraph();*/

		start = true;
	}
	

	private void updateTraffic(int trafficType) {
		//paneTraffic.updateTraffic(trafficType);
		frame.repaint();
	}
	
	public void setDownloadTraffic(String traffic) {
		paneTraffic.setDownloadTraffic(traffic);
		frame.repaint();
	}
	
	public void setUploadTraffic(String traffic) {
		paneTraffic.setUploadTraffic(traffic);
		frame.repaint();
	}
	
	public void setTraffic(String download, String upload) {
		paneTraffic.setTraffic(download, upload);
		frame.repaint();
	}
	
	public void clearTraffic() {
		paneTraffic.clearTraffic();
		frame.repaint();
	}
	
	public void clearGraphData() {
		graphDataset.clear();
	}
	
	public void addGraphData(Double newData, int count) {
		graphDataset.addValue(newData, "Entropy", String.valueOf(count));
	}
	
	public void addGraphData(Double newData) {
		graphDataset.addValue(newData, "Entropy", String.valueOf(graphDataset.getColumnCount()+1));
	}
	
	public void addGraphData(int newData) {
		graphDataset.addValue(newData, "Entropy", String.valueOf(graphDataset.getColumnCount()+1));
		
	}
	
	public void updateGraph() {
		JFreeChart chart;
        chart = ChartFactory.createBarChart("Entropy remained v.s. Number of reruns",
        		"Number of reruns", "Entropy remained", graphDataset, PlotOrientation.VERTICAL, false,
        		true, false);
        CategoryPlot plot = chart.getCategoryPlot();
        Font font = new Font("SansSerif", Font.BOLD, 22);
        CategoryAxis axis = plot.getDomainAxis();
        axis.setLabelFont(font);
        ValueAxis axis2 = plot.getRangeAxis();
        axis2.setLabelFont(font);
        chart.draw(g2, chartArea);
		frame.repaint();

	}
	
	public void log(String msg) {
        JTextArea log = getLogObject();
        log.append(msg);
}
	
	public void start() {
		
	}
	
	public void showResult(String result) {
		//JOptionPane.showMessageDialog(this, result, "Result report", JOptionPane.INFORMATION_MESSAGE);
		JDialog myDialog = new JDialog();
		JOptionPane.showMessageDialog(myDialog, result);
		/*
		JOptionPane.showMessageDialog(this,
				result,
				"Result Report",
				JOptionPane.INFORMATION_MESSAGE) //,
				//JOptionPane.YES_OPTION);
				
				 */
		end = true;
	}

	public boolean isDectectionStarted() {
		return paneDect.start;
	}
	
	public boolean isDectectionStopped() {
		return paneDect.stop;
	}
	
	public void log2(String msg) {
		JTextArea logObj = paneDect.getLogObj();
		logObj.append(msg + "\n");
	}
	public void selectTab(int index) {
		paneTabbed.setSelectedIndex(index);
	}
	/**
	 * @param args
	 */
	   public static void main(String[] args) {
		   //Schedule a job for the event-dispatching thread:
		   //creating and showing this application's GUI.
		   final SidebusterDemo fd = new SidebusterDemo();
		   fd.addGraphData(20);
		   fd.updateGraph();
		   fd.updateTraffic(3);
		   fd.setUrl("http://income-test.appspot.com/");
		   JTextArea log = fd.getLogObject();
		   log.append(fd.getUrl());
		   //fd.testAddToGraphDataset();
		   int count = 100;
		   while (count > 95) {
			   //fd.addGraphData(count);
			   //fd.updateGraph();
			   fd.setDownloadTraffic(String.valueOf(count));
			   try {
				Thread.sleep(500);
			   } catch (InterruptedException e) {
				   // TODO Auto-generated catch block
				   e.printStackTrace();
			   }
			   count --;
		   }
		   fd.showResult("Finished");
		   //fd.showResult(fd.getFrameSize().toString());
		   //Dimension d = fd.getFrameSize();
		   ///fd.setFrameSize(d.width + 100 ,d.height);
       		
       		
		   
		   
		   /*
		   javax.swing.SwingUtilities.invokeLater(new Runnable() {
	            public void run() {
	            	SidebusterDemo fd = new SidebusterDemo();

	            	
	                //FrameDemo.createAndShowGUI();
	                //fd.createAndShowGUI();
	            }
	        });*/
		   
	    }
}
