/**
 * 
 */
package testframework.ui;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.LayoutManager;
import java.awt.Panel;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.image.BufferedImage;
import java.io.File;

import javax.imageio.ImageIO;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;

/**
 * @author zkh
 *
 */
public class TrafficPanel extends JPanel {
	BufferedImage image_client;
	BufferedImage image_server;
	BufferedImage image_traffic_down;
	BufferedImage image_traffic_up;
	
	String trafficDownload = "";
	String trafficUpload = "";
	
	
	int init_x = 20;
	int init_y = 50;
	
	int icon_width=140;
	int icon_height=140;
	int icon_arrow_width=100;
	int icon_arrow_height=30;
	int icon_arrow_up_y = init_y + 20;
	int icon_arrow_down_y = init_y + 100;
	int txtOffset = 20;
	

	
	int trafficType; // 0-> no traffic; 1-> upload, 2->download, 3-> both
	int hasUploadTraffic;
	int hasDownloadTraffic;
	
	Font font;
	

	/**
	 * 
	 */
	public TrafficPanel(Font font) {
		this.setLayout(new BorderLayout());
		this.font = font;
		try {
			String curDir = System.getProperty("user.dir");
/*
			ImageIcon icon_server = new ImageIcon(curDir + "\\image\\icon_server.PNG");
			ImageIcon icon_client = new ImageIcon(curDir + "\\image\\icon_client.PNG");
			ImageIcon icon_traffic_download = new ImageIcon(curDir + "\\image\\icon_arrow_down_red.PNG");
			ImageIcon icon_traffic_upload = new ImageIcon(curDir + "\\image\\icon_arrow_up_red.PNG");
			*/
			
			File imageFile;
			imageFile = new File(curDir + "\\image\\icon_server.PNG");
			image_server = ImageIO.read(imageFile);
			imageFile = new File(curDir + "\\image\\icon_client.PNG");
			image_client = ImageIO.read(imageFile);
			imageFile = new File(curDir + "\\image\\icon_arrow_down_red.PNG");
			image_traffic_down = ImageIO.read(imageFile);
			imageFile = new File(curDir + "\\image\\icon_arrow_up_red.PNG");
			image_traffic_up = ImageIO.read(imageFile);

			setBackground(Color.WHITE);
			
			trafficType = 3;
			
/*			
			JLabel lblDownload = new JLabel(icon_traffic_download);
			JLabel lblUpload = new JLabel(icon_traffic_upload);
			JLabel lblServer = new JLabel(icon_server);
			JLabel lblClient = new JLabel(icon_client);
			
			//this.add(lblDownload, BorderLayout.CENTER);
			//this.add(lblUpload, BorderLayout.CENTER);
			this.add(lblServer, BorderLayout.EAST);
			this.add(lblClient, BorderLayout.WEST);
			
			lblServer.setSize(60,60);
			lblClient.setSize(60,60);
			
			*/
			//this.setSize(300, 300);
			 
			
			 
			/*

			*/

		} catch (Exception e) {
			System.out.println(e.toString());
		}
	}

	private void updateTraffic(int trafficType) {
		this.trafficType = trafficType % 4;		
	}
	public int getTrafficType() {
		return trafficType;		
	}
	
	public void paint(Graphics g) {
		//g.drawChars(trafficUpload.toCharArray(), 0, trafficUpload.length(), init_x+icon_width, init_y-10);
		//g.drawChars(trafficDownload.toCharArray(), 0, trafficDownload.length(), init_x+icon_width, init_y + icon_height +10);
		g.setFont(font);
		g.drawString(trafficUpload, init_x+icon_width + txtOffset, init_y-10);
		g.drawString(trafficDownload, init_x+icon_width + txtOffset, init_y + icon_height +10);


		g.drawImage(image_client, init_x, init_y, icon_width, icon_height, null);
		if (trafficType / 2 == 1 )
			g.drawImage(image_traffic_down, init_x+icon_width, icon_arrow_down_y, icon_arrow_width, icon_arrow_height, null);
		if (trafficType %2 == 1)
			g.drawImage(image_traffic_up, init_x+icon_width, icon_arrow_up_y, icon_arrow_width, icon_arrow_height, null);
		g.drawImage(image_server, init_x+icon_width+icon_arrow_width, init_y, icon_width, icon_height, null);

	}

	/**
	 * @param layout
	 */
	public TrafficPanel(LayoutManager layout) {
		super(layout);
		// TODO Auto-generated constructor stub
	}

	/**
	 * @param isDoubleBuffered
	 */
	public TrafficPanel(boolean isDoubleBuffered) {
		super(isDoubleBuffered);
		// TODO Auto-generated constructor stub
	}

	/**
	 * @param layout
	 * @param isDoubleBuffered
	 */
	public TrafficPanel(LayoutManager layout, boolean isDoubleBuffered) {
		super(layout, isDoubleBuffered);
		// TODO Auto-generated constructor stub
	}

	public void setDownloadTraffic(String traffic) {
		this.trafficDownload = (traffic);
		this.trafficUpload = "";
		this.trafficType = 2;
	}
	
	public void setUploadTraffic(String traffic) {
		this.trafficUpload = (traffic);
		this.trafficDownload = "";
		this.trafficType = 1;
	}
	
	public void setTraffic(String download, String upload) {
		this.trafficDownload = (download);
		this.trafficUpload = (upload);
		this.trafficType = 3;
	}
	
	public void clearTraffic() {
		this.trafficDownload = ("");
		this.trafficUpload = ("");
		this.trafficType = 0;		
	}
	/**
	 * @param args
	 */

	static public void main(String args[]) throws  Exception {
		JFrame frame = new JFrame("Display image");
		Font font = frame.getFont();
		TrafficPanel panel = new TrafficPanel(font);
		frame.getContentPane().add(panel);
		/*
		JButton bt = new JButton("Update");
		frame.getContentPane().add(bt);
		bt.addActionListener(new ActionListener () {

			@Override
			public void actionPerformed(ActionEvent e) {
				panel.updateTraffic();
			}
		});
		*/
		frame.setSize(500, 500);
		frame.setVisible(true);
	}

}
