/**
 * 
 */
package testframework.utils;

import testframework.Command;
import testframework.HtmlUnitWrapper;

/**
 * @author lzcarl
 *
 */
public class ControlUtils {
	
	public static HtmlUnitWrapper htmlUnit;
	
	/**
	 * get the maximum number of input given the character count
	 * assume only alphabets can be inputted
	 * @param count
	 * @return
	 */
	public static int getTextBoxRange(int count) {
		//consider zzz, that's the maximum for count = 3
		//26^3 + 26^2 + 26
		return (int)(Math.pow(26, count + 1) - 1) / 25 - 1;
	}
	
	/**
	 * get the string value of input given the index
	 * For example, if index is 263, the corresponding string is jc
	 * 263 = 10 *26 + 3
	 * @param index
	 * @return
	 */
	public static String getTextBoxValue(int index) {
		int m,n = 0;
		char c = 0;
		String str = "";
		int reminder = index;
		while(reminder > 0) {
			n = (reminder - 1) % 26;
			m = (reminder - 1) / 26;
			reminder = m;
			c = (char)(n + 65);
			str = c + str;
		};
		return str;
	}
	
	public static boolean disabled(Command cmd) throws Exception{
		if(!htmlUnit.getControlExist(cmd.name)) {
			return true;
		} else if(cmd.type.equals("ListBox") && htmlUnit.getlistDisabled(cmd.name)) {
			return true;
		} else {
			return false;
		}
	}
	
	public static void setRange(Command cmd) throws Exception{
		if(!htmlUnit.getControlExist(cmd.name)) {
			cmd.range = 0;
		}else if(cmd.type.equals("ListBox"))
			cmd.range = htmlUnit.getListSize(cmd.name);
		else if(cmd.type.equals("TextBox"))
			cmd.range = ControlUtils.getTextBoxRange(Integer.parseInt(cmd.count));
		else if (cmd.type.equals("Table")) {
			cmd.range = htmlUnit.getTableSize(cmd.name);
		} else{
			cmd.range = Integer.parseInt(cmd.count);
		}
	}
	
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub
		System.out.println(getTextBoxValue(getTextBoxRange(3)));
		//for(int i = 0; i < 800; i ++)
			//System.out.println(i + ":" + getTextBoxValue(i));
	}
	
}
