package testframework.utils;

import java.text.SimpleDateFormat;
import java.util.Calendar;
import testframework.ui.*;

public class Tracer {
	public static final String DATE_FORMAT_NOW = "HH:mm:ss.SSS";
	
	public static SidebusterDemo demo; 
	
	public static String now() {
		Calendar cal = Calendar.getInstance();
		SimpleDateFormat sdf = new SimpleDateFormat(DATE_FORMAT_NOW);
		return sdf.format(cal.getTime());
	}
	
	public static void updateTraffic(String direction, String size) {
		if(direction.equals("<")) {
			demo.setUploadTraffic(size);
		} else if(direction.equals(">")) {
			demo.setDownloadTraffic(size);
		} else {
			demo.clearTraffic();
		}
	}
	
	public static void trace(String msg) {
		System.out.println(now() + ": " + msg);
		demo.log(msg + "\n");
	}
	
	/**
	 * not print to ui
	 * @param msg
	 */
	public static void trace_text(String msg) {
		System.out.println(now() + ": " + msg);
	}
}
