package traffic;

/**
 * 
 */


import java.io.BufferedOutputStream;
import java.io.BufferedReader;
import java.io.DataInputStream;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.InputStreamReader;
import java.io.PrintStream;
import java.io.UnsupportedEncodingException;
import java.util.Enumeration;
import java.util.StringTokenizer;
import java.util.Vector;

import jpcap.packet.*;
import jpcap.JpcapCaptor;
import jpcap.NetworkInterface;
import jpcap.NetworkInterfaceAddress;

import testframework.TestResult;

/**
 * @author t-ruwang
 *
 */
public class TrafficAnalyser { 
	public static boolean InTransaction = false;
	private static Vector<MyPacket> packets = new Vector<MyPacket>();
	public static long lastReceiveTime = System.currentTimeMillis(); //current time 
	private static int timestamp = 0; //global timestamp
	public static String clientIP;
	public static String NIC;
	public static String proto;
	public static TestResult result;
	private static Tcpdump tcpdump;
	
	/**
	 * @param args
	 * @throws Exception 
	 */
	public static void main(String[] args) throws Exception {
		if (args.length != 3) {
			System.out.println("usage: java -jar test.jar NIC clientIP protocol");
			System.out.println("NIC is the index of the network device");
			System.out.println("clientIP is client IP address");
			System.out.println("protocol denotes the protocol of the sniffed traffic");
			printDeviceList();
			System.exit(0);
		}
		
//		System.setOut(
//			    new PrintStream(
//			      new BufferedOutputStream(
//			       new FileOutputStream("OUTPUT.DAT"))));
		
		MyPacket.clientIP = args[1]; //client IP address
		Tcpdump.proto = Tcpdump.getProtocolFromString(args[2]);
		String filter = "tcp and host "+MyPacket.clientIP; //filter
		tcpdump = new Tcpdump(Integer.valueOf(args[0]),filter,Tcpdump.TransactionStatus.NoTransaction, MyPacket.clientIP); //tcpdump will run, and print traffic
	}
	
	public static void defaultStart() throws Exception {
		MyPacket.clientIP = clientIP; //client IP address
		Tcpdump.proto = Tcpdump.getProtocolFromString(proto);
		String filter = "tcp and host "+MyPacket.clientIP; //filter
		tcpdump = new Tcpdump(Integer.valueOf(NIC),filter,Tcpdump.TransactionStatus.NoTransaction, clientIP); //tcpdump will run, and print traffic
		
	}
	
	public static void stop() throws Exception {
		if(!(tcpdump == null))
			tcpdump.stop();
	}

	private static void printDeviceList() {
		//Obtain the list of network interfaces
		NetworkInterface[] devices = JpcapCaptor.getDeviceList();
		
		//for each network interface
		for (int i = 0; i < devices.length; i++) {  
			//print out its name and description  
			System.out.println(i+": "+devices[i].name + "(" + devices[i].description+")");  
			//print out its datalink name and description  
			System.out.println(" datalink: "+devices[i].datalink_name + "(" + devices[i].datalink_description+")");  
			//print out its MAC address  
			System.out.print(" MAC address:");  
			for (byte b : devices[i].mac_address)    
				System.out.print(Integer.toHexString(b&0xff) + ":");  
			System.out.println();  
			
			//print out its IP address, subnet mask and broadcast address  
			for (NetworkInterfaceAddress a : devices[i].addresses)
				System.out.println(" address:"+a.address + " " + a.subnet + " "+ a.broadcast);
		}
	}

	/**
	 * @param packet
	 * @return
	 * generate arrival time for packet
	 */
	private static double getPacketArrivalTime(Packet packet) {
		return packet.sec+packet.usec*1e-6;
	}

	public static void appendToPacketPool(MyPacket packet) {
		packets.add(packet);
	}

}
